var id=window.location.hash.split('#')[1]
if(!id) window.location='../'
var url=baseUrl+id+'?'
$("#newUrl").attr('href',url+'ical').text(url+'ical')
var replaceFields=['field','from','to','description']
var replace=[]
var regexReplace=[]
var filters=[]
var originalData=[]
var saved=true
const headers=['SUMMARY','UID','LOCATION','DTSTART','DTEND','DESCRIPTION']
function replaceDate(event) {
	['DTSTART','DTEND'].forEach(function(cell) {
		var list=event[cell].split('')
		event[cell]=list.splice(0,4).join('')+'-'+list.splice(0,2).join('')+'-'+list.splice(0,2).join('')+' '+list.splice(1,2).join('')+':'+list.splice(1,2).join('')
	})
	return event
}
function replaceDefault(event) {
	headers.forEach(function(header) {
		event[header]=replaceAll(event[header],'\\n','<br>')
	})
	return replaceDate(event)
}
function generateFilterRow(action) {
	return '<tr class="dataRow"><td><input type="text" class="field" value="'+action.field+'"></td><td><input class="text" type="text" value="'+action.text+'"></td><td><select class="action"><option value="include">include</option><option value="exclude"'+(action.action=="exclude"?' selected':'')+'>exclude</option></select></td><td><input type="text" class="description" value="'+action.description+'"></td><td><button class="deleteFilterRow">Delete rij</button><button class="insertFilterRowAbove">Nieuwe regel hierboven</button></td></tr>'
}
function generateReplaceRow(replace) {
	return '<tr class="dataRow">'+replaceFields.map(function(field) {return '<td><input type="text" value="'+replace[field]+'" class="'+field+'"></td>'})+'<td><button class="deleteReplace">delete row</button><button class="insertReplaceAbove">Nieuwe regel hierboven</button></tr>'
}
function addReplace(table,replace) {
	$('#'+table).append(generateReplaceRow(replace))
}
function addFilter(filter) {
	html='<div class="filter"><table border="1" class="filterTable"><tr><th>veld</th><th>text</th><th>actie</th><th>description</th></tr>'
	filter.forEach(function(action) {
		html+=generateFilterRow(action)
	})
	html+='</table><button class="newFilterRow thisButton">Nieuwe rij</button><button class="deleteFilter">Delete filter</button></div>'
	$('#filters').append(html)
	if(filter.length==0) {$('.thisButton').click()}
	$('.thisButton').toggleClass('thisButton')
}
$(document).on('click','.newFilterRow',function () {
	$(this).parent().children('.filterTable').append(generateFilterRow({field:'SUMMARY',text:'',action:'include',description:''}))
})
$(document).on('click','.deleteFilterRow',function () {
	if(confirm('wil je deze rij echt verwijderen?')) $(this).parent().parent().remove()
})
$(document).on('click','.deleteFilter',function () {
	if(confirm('wil je dit filter echt verwijderen?')) $(this).parent().remove()
})
$(document).on('click','.deleteReplace',function () {
	if(confirm('wil je deze zoeken/vervangen echt verwijderen?')) $(this).parent().parent().remove()
})
$(document).on('click','.insertFilterRowAbove',function () {
	$(this).parent().parent().before(generateFilterRow({field:'SUMMARY',text:'',action:'include',description:''}))
})
$(document).on('click','.insertReplaceAbove',function () {
	$(this).parent().parent().before(generateReplaceRow({field:'SUMMARY',from:'',to:'',description:''}))
})
$(document).on('click','.filterUid',function () {
	uid=$(this).parent().parent().find('.UID').text()
	addFilter([{field:'UID',text:uid,action:'include'}])
})
function checkRegex(action) {
	try {
		new RegExp(action)
		return true
	} catch(e) {
		return false
	}
}
function checkRegexes() {
	$('#regexReplaceTable').find('.dataRow').find('.from').each(function(id,input) {
		var input = $(input)
		if(checkRegex(input.val())) input.parent().removeClass('invalidRegex')
		else input.parent().addClass('invalidRegex')
	})
}
function updateData() {
    saved=false
    checkRegexes()
    if($('#autoUpdate').is(':checked')) {
		replace=getReplace('replaceTable')
		regexReplace=getReplace('regexReplaceTable')
		filters=getFilters()
		updateTable()
	}
}
$(document).on("change keyup paste", 'input', updateData)
$(document).on("click", 'button', updateData)
$('#newFilter').on('click',function () {
	addFilter([])
})
$('#newReplace').on('click',function () {
	addReplace('replaceTable',{field:'SUMMARY',from:'',to:'',description:''})
})
$('#newRegexReplace').on('click',function () {
	addReplace('regexReplaceTable',{field:'SUMMARY',from:'',to:'',description:''})
})
function getFilters() {
	var filters=[]
	$('#filters').children('.filter').each(function(id,filterHtml) {
		var filter=[]
		$(filterHtml).children('.filterTable').find('.dataRow').each(function(id,action) {
			action=$(action)
			filter.push({field:action.find('.field').val(),text:action.find('.text').val(),action:action.find('.action').val(),description:action.find('.description').val()})
		})
		filters.push(filter)
	})
	return filters
}
function getReplace(table) {
	var replaces=[]
	$('#'+table).find('.dataRow').each(function(id,row) {
		row=$(row)
		var replace={}
		replaceFields.forEach(function(field) {
			replace[field]=row.find('.'+field).val()
		})
		replaces.push(replace)
	})
	return replaces
}

function updateTable() {
	$('#afspraken').html('<tr><th>'+headers.join('</th><th>')+'</th></tr>')
	JSON.parse(JSON.stringify(originalData)).forEach(function(line) {
		if(filterEvent(line,filters)) color='none'
		else if($('#showRed').is(':checked')) color='red'
		else return
		line=replaceEvent(line,regexReplace,true,true)
		line=replaceEvent(line,replace,true)
		line=replaceDefault(line)
		$('#afspraken').append('<tr class="'+color+'">'+headers.map(function (item) {return '<td class="'+item+'">'+line[item]+'</td>'}).join('')+'<td><button class="filterUid">x</button></td></tr>')
	})
	if(!$('#showRed').is(':checked')) {
		$('.red').hide()
	}
}
function update() {
	$.get(url+'settings',function(settings) {
		console.log(settings)
		$('#url').val(settings.url)
		$('#filters').html('')
		$('#replaceTable').html('<tr>'+replaceFields.map(function (field) {return '<th>'+field+'</th>'})+'</tr>')
		$('#regexReplaceTable').html('<tr>'+replaceFields.map(function (field) {return '<th>'+field+'</th>'})+'</tr>')
		filters=settings.filters
		replace=settings.replace
		regexReplace=settings.regexReplace
		settings.filters.forEach(addFilter)
		settings.replace.forEach(function (item) {addReplace('replaceTable',item)})
		settings.regexReplace.forEach(function (item) {addReplace('regexReplaceTable',item)})
	})
	$.get(url+'json',function (data) {
		console.log(data)
		originalData=data
		updateTable()
	})
}
$('#submit').on('click',function () {
	settings={
		id:id,
		url:$('#url').val().replace('webcal','http'),
		replace:getReplace('replaceTable'),
		regexReplace:getReplace('regexReplaceTable'),
		filters:getFilters()
	}
	$('#submit').prop('disabled',true)
	$.post(url,JSON.stringify(settings),function (data) {
		$('#submit').prop('disabled',false)
		update()
		saved=true
	},'json').fail(function () {
		alert('opslaan mislukt!')
		$('#submit').prop('disabled',false)
	})
})
update()


$(window).on('beforeunload', function(e) {
    if(!saved) {
        return 'Nog niet alles is opgeslagen. wil je echt sluiten?';
    }
});
